<?php

declare(strict_types=1);

namespace IQDEV\Packages\DoctrineHttpFilter\Filter;

use Doctrine\ORM\QueryBuilder;
use IQDEV\Packages\DoctrineHttpFilter\Exception\FilterParameterValueIsNullException;
use IQDEV\Packages\DoctrineHttpFilter\HttpFilter;

final class DateRange extends HttpFilter
{
    /**  @throws FilterParameterValueIsNullException */
    public function addToQuery(QueryBuilder $queryBuilder): QueryBuilder
    {
        if (! isset($this->getHttpValue()['from']) && ! isset($this->getHttpValue()['to'])) {
            throw new FilterParameterValueIsNullException($this->field);
        }

        if (isset($this->getHttpValue()['from'])) {
            $queryBuilder->where(
            'strftime(\'%Y-%m-%d\', ' . $this->getColumn() . ') >= \'' . $this->getHttpValue()['from'] . '\'',
            );
        }

        if (isset($this->getHttpValue()['to'])) {
            $queryBuilder->andWhere(
                'strftime(\'%Y-%m-%d\', ' . $this->getColumn() . ') <= \'' . $this->getHttpValue()['to'] . '\'',
            );
        }

        return $queryBuilder;
    }
}
